/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the CompleteSelfServiceResetRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CompleteSelfServiceResetRequest{}

// CompleteSelfServiceResetRequest struct for CompleteSelfServiceResetRequest
type CompleteSelfServiceResetRequest struct {
	Code        *string        `json:"code,omitempty"`
	NewPassword NullableString `json:"newPassword,omitempty"`
}

// NewCompleteSelfServiceResetRequest instantiates a new CompleteSelfServiceResetRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCompleteSelfServiceResetRequest() *CompleteSelfServiceResetRequest {
	this := CompleteSelfServiceResetRequest{}
	return &this
}

// NewCompleteSelfServiceResetRequestWithDefaults instantiates a new CompleteSelfServiceResetRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCompleteSelfServiceResetRequestWithDefaults() *CompleteSelfServiceResetRequest {
	this := CompleteSelfServiceResetRequest{}
	return &this
}

// GetCode returns the Code field value if set, zero value otherwise.
func (o *CompleteSelfServiceResetRequest) GetCode() string {
	if o == nil || IsNil(o.Code) {
		var ret string
		return ret
	}
	return *o.Code
}

// GetCodeOk returns a tuple with the Code field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CompleteSelfServiceResetRequest) GetCodeOk() (*string, bool) {
	if o == nil || IsNil(o.Code) {
		return nil, false
	}
	return o.Code, true
}

// HasCode returns a boolean if a field has been set.
func (o *CompleteSelfServiceResetRequest) HasCode() bool {
	if o != nil && !IsNil(o.Code) {
		return true
	}

	return false
}

// SetCode gets a reference to the given string and assigns it to the Code field.
func (o *CompleteSelfServiceResetRequest) SetCode(v string) {
	o.Code = &v
}

// GetNewPassword returns the NewPassword field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *CompleteSelfServiceResetRequest) GetNewPassword() string {
	if o == nil || IsNil(o.NewPassword.Get()) {
		var ret string
		return ret
	}
	return *o.NewPassword.Get()
}

// GetNewPasswordOk returns a tuple with the NewPassword field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *CompleteSelfServiceResetRequest) GetNewPasswordOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.NewPassword.Get(), o.NewPassword.IsSet()
}

// HasNewPassword returns a boolean if a field has been set.
func (o *CompleteSelfServiceResetRequest) HasNewPassword() bool {
	if o != nil && o.NewPassword.IsSet() {
		return true
	}

	return false
}

// SetNewPassword gets a reference to the given NullableString and assigns it to the NewPassword field.
func (o *CompleteSelfServiceResetRequest) SetNewPassword(v string) {
	o.NewPassword.Set(&v)
}

// SetNewPasswordNil sets the value for NewPassword to be an explicit nil
func (o *CompleteSelfServiceResetRequest) SetNewPasswordNil() {
	o.NewPassword.Set(nil)
}

// UnsetNewPassword ensures that no value is present for NewPassword, not even an explicit nil
func (o *CompleteSelfServiceResetRequest) UnsetNewPassword() {
	o.NewPassword.Unset()
}

func (o CompleteSelfServiceResetRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CompleteSelfServiceResetRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Code) {
		toSerialize["code"] = o.Code
	}
	if o.NewPassword.IsSet() {
		toSerialize["newPassword"] = o.NewPassword.Get()
	}
	return toSerialize, nil
}

type NullableCompleteSelfServiceResetRequest struct {
	value *CompleteSelfServiceResetRequest
	isSet bool
}

func (v NullableCompleteSelfServiceResetRequest) Get() *CompleteSelfServiceResetRequest {
	return v.value
}

func (v *NullableCompleteSelfServiceResetRequest) Set(val *CompleteSelfServiceResetRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableCompleteSelfServiceResetRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableCompleteSelfServiceResetRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCompleteSelfServiceResetRequest(val *CompleteSelfServiceResetRequest) *NullableCompleteSelfServiceResetRequest {
	return &NullableCompleteSelfServiceResetRequest{value: val, isSet: true}
}

func (v NullableCompleteSelfServiceResetRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCompleteSelfServiceResetRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
